'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.yomoApp0 = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _mobx = require('mobx');

var _mobx2 = _interopRequireDefault(_mobx);

var _cacheFn = require('./cacheFn.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var observable = _mobx2.default.observable;
var asReference = _mobx2.default.asReference;
var useStrict = _mobx2.default.useStrict;

useStrict(true);

var ok = {
  reducer: 1, ViewException: 1, run: 1, render: 1, View: 1, css: 1
};
var yomoApp0 = exports.yomoApp0 = function yomoApp0(spec, curry) {
  if (curry) {
    return function (spec2, curry2) {
      return yomoApp0(_extends({}, spec, spec2), curry2);
    };
  }
  var reducer = spec.reducer;
  var ViewException = spec.ViewException;
  var run = spec.run;
  var render = spec.render;

  for (var k in spec) {
    if (!ok[k]) {
      console.log('Warning in yomoApp --- unknown key: ' + k);
    }
  }

  var state = observable(asReference(undefined));
  var yomo = function yomo() {
    return state.get();
  };
  yomo.cache = {};
  yomo.ViewException = ViewException;

  yomo.dispatchSoon = function (action) {
    return process.nextTick(yomo.dispatch, action);
  };
  yomo.dispatch = _mobx2.default.action(function (action) {
    return state.set(reducer(state.get(), action));
  });
  yomo.dispatch({ type: '@@redux/INIT' });

  run && run.forEach(function (fn) {
    return (0, _cacheFn.yomoRun)(yomo, function () {
      return fn(yomo);
    });
  });
  render && render(spec, yomo, spec);
};