'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.yomoReact = exports.yomoView = exports.Provider = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _withContext = require('recompose/withContext');

var _withContext2 = _interopRequireDefault(_withContext);

var _getContext = require('recompose/getContext');

var _getContext2 = _interopRequireDefault(_getContext);

var _mobxReact = require('mobx-react');

var _myExceptions = require('../util/my-exceptions.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Provider = exports.Provider = (0, _withContext2.default)({
  yomo: _react2.default.PropTypes.func,
  store: _react2.default.PropTypes.object
}, function (props) {
  return { yomo: props.yomo, store: props.store };
})(function (_ref) {
  var children = _ref.children;
  return _react2.default.createElement(
    'div',
    null,
    children
  );
});

var yomoView = exports.yomoView = function yomoView(View, options) {
  return (0, _mobxReact.observer)((0, _getContext2.default)({ yomo: _react2.default.PropTypes.func })(function (props) {
    try {
      return View(props);
    } catch (exception) {
      var waiting = (0, _myExceptions.isWaitX)(exception);
      var V = props.yomo.ViewException || null;
      return V && _react2.default.createElement(V, { waiting: waiting, exception: exception, options: options });
    }
  }));
};

var yomoReact = exports.yomoReact = {
  render: function render(_ref2, yomo, spec) {
    var View = _ref2.View;
    var domId = _ref2.domId;

    var css = spec.css || null;
    var CSS = css && _react2.default.createElement(
      'style',
      { media: 'screen', type: 'text/css' },
      css
    );
    return View && _reactDom2.default.render(_react2.default.createElement(
      Provider,
      { yomo: yomo },
      CSS,
      _react2.default.createElement(View, null)
    ), document.getElementById(domId || 'root'));
  }
};