'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ProgramErrorIcon = exports.UserErrorIcon = exports.OkIcon = exports.DelayIcon = exports.WaitIcon = exports.ticks = exports.delay = exports.getJSON = exports.getText = exports.getBuffer = exports.combineReducers = exports.reuse = exports.cacheSlow = exports.onOffActionShared = exports.onOffAction = exports.getPipe = exports.pipes = exports.linkPipes = exports.yomoBridge = undefined;

var _cacheFn = require('./core/cacheFn.js');

var _reuse = require('./util/reuse.js');

var _pipes = require('./core/pipes.js');

var _getx = require('./util/getx.js');

var _time = require('./util/time.js');

var _mqttIpc = require('./core/mqtt-ipc');

var _bridge = require('./core/bridge.js');

var _icons = require('./util/icons.js');

var yomoBridge = function yomoBridge(bSpec, ipcSpec) {
  return (0, _bridge.ipcBridge)(_mqttIpc.mqttIpc, bSpec, ipcSpec);
};

exports.yomoBridge = yomoBridge;
exports.linkPipes = _pipes.linkPipes;
exports.pipes = _pipes.pipes;
exports.getPipe = _pipes.getPipe;
exports.onOffAction = _cacheFn.onOffAction;
exports.onOffActionShared = _cacheFn.onOffActionShared;
exports.cacheSlow = _cacheFn.cacheSlow;
exports.reuse = _reuse.reuse;
exports.combineReducers = _reuse.combineReducers;
exports.getBuffer = _getx.getBuffer;
exports.getText = _getx.getText;
exports.getJSON = _getx.getJSON;
exports.delay = _time.delay;
exports.ticks = _time.ticks;
exports.WaitIcon = _icons.WaitIcon;
exports.DelayIcon = _icons.DelayIcon;
exports.OkIcon = _icons.OkIcon;
exports.UserErrorIcon = _icons.UserErrorIcon;
exports.ProgramErrorIcon = _icons.ProgramErrorIcon;